## mingw-w64-wasm-tools-1.245.1-1.src.tar.zst

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(wasm-tools-examples)

add_library(wasm-tools-examples STATIC
	wasm-smith.c
)

add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/../crates/c-api ${CMAKE_CURRENT_BINARY_DIR}/wasm-tools)

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
	target_compile_options(wasm-tools-examples PRIVATE -Wall -Wextra -Wno-deprecated-declarations)
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
	target_compile_options(wasm-tools-examples PRIVATE /W4)
endif()

set_target_properties(wasm-tools-examples PROPERTIES
		OUTPUT_NAME "examples"
		RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
		CXX_VISIBILITY_PRESET hidden
		POSITION_INDEPENDENT_CODE ON)

target_include_directories(wasm-tools-examples PUBLIC wasm-tools)
target_link_libraries(wasm-tools-examples PUBLIC wasm-tools)

=== crates/c-api/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

# Copy shared library into build directory
if(WIN32)
	set(WASM_TOOLS_INSTALL_COMMAND ${CMAKE_COMMAND} -E copy_if_different
		${CMAKE_CURRENT_SOURCE_DIR}/../../target/release/wasmtools.dll
		${CMAKE_BINARY_DIR})
elseif(APPLE)
	set(WASM_TOOLS_INSTALL_COMMAND ${CMAKE_COMMAND} -E copy_if_different
		${CMAKE_CURRENT_SOURCE_DIR}/../../target/release/libwasmtools.dylib
		${CMAKE_BINARY_DIR})
else()
	set(WASM_TOOLS_INSTALL_COMMAND ${CMAKE_COMMAND} -E copy_if_different
		${CMAKE_CURRENT_SOURCE_DIR}/../../target/release/libwasmtools.so
		${CMAKE_BINARY_DIR})
endif()

include(ExternalProject)
ExternalProject_Add(
	wasm-tools-crate
	DOWNLOAD_COMMAND ""
	CONFIGURE_COMMAND ""
	INSTALL_COMMAND "${WASM_TOOLS_INSTALL_COMMAND}"
	BUILD_COMMAND cargo build --release
	BINARY_DIR ${CMAKE_CURRENT_SOURCE_DIR}
	BUILD_ALWAYS ON)
add_library(wasm-tools INTERFACE)
add_dependencies(wasm-tools wasm-tools-crate)

if(WIN32)
	target_link_libraries(wasm-tools INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}/../../target/release/wasmtools.dll.lib)
elseif(APPLE)
	target_link_libraries(wasm-tools INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}/../../target/release/libwasmtools.dylib)
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-rpath='$ORIGIN'")
else()
	target_link_libraries(wasm-tools INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}/../../target/release/libwasmtools.so)
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-rpath='$ORIGIN'")
endif()

target_include_directories(wasm-tools INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}/include)

=== PKGBUILD ===
# Maintainer: Maksim Bondarenkov <maksapple2306@gmail.com>

_realname=wasm-tools
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.245.1
pkgrel=1
pkgdesc="Low level tooling for WebAssembly in Rust (mingw-w64)"
arch=("any")
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url="https://github.com/bytecodealliance/wasm-tools"
msys2_repository_url="https://github.com/bytecodealliance/wasm-tools"
license=('spdx:Apache-2.0 WITH LLVM-exception AND Apache-2.0 AND MIT')
# Update using ./retrieve-testsuite-commit.sh <pkgver>
_wasm_testsuite_commit=e999a1051925895022ab06abc25b23ca300ab0d0
makedepends=("${MINGW_PACKAGE_PREFIX}-rust" 'git')
source=(
  "https://github.com/bytecodealliance/${_realname}/archive/refs/tags/v${pkgver}/${_realname}-${pkgver}.tar.gz"
	"https://github.com/WebAssembly/testsuite/archive/${_wasm_testsuite_commit}/wasm-testsuite-${_wasm_testsuite_commit}.tar.gz"
)
sha256sums=('f8fc02ceec50f0188e4128159535e6c4195594e74c56ecc1db3113e62feb477d'
            'e289c03b4586b92f5e59e30078c4ea96d79fbdc59d993e866c694893473c315c')

prepare() {
  cd "${_realname}-${pkgver}"
  rm -r tests/testsuite
  cp -r "../testsuite-${_wasm_testsuite_commit}" tests/testsuite
  cargo fetch \
    --locked \
    --target "${RUST_CHOST}" \
    --config='net.git-fetch-with-cli=true'
}

build() {
  cd "${_realname}-${pkgver}"
  cargo build --frozen --release --all-features --bin wasm-tools
}

check() {
  cd "${_realname}-${pkgver}"
  cargo test --frozen --release --all-features
}

package() {
  cd "${_realname}-${pkgver}"
  install -Dm0755 -t "${pkgdir}${MINGW_PREFIX}/bin/" "target/release/${_realname}"
  install -Dm0644 -t "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}" LICENSE-*
}
